/*
	file automatically generated by make_test_files.pl
	Thu Jan  5 10:43:59 2006
*/

/*****************************************************************************
 *                                                                           *
 *          UNURAN -- Universal Non-Uniform Random number generator          *
 *                                                                           *
 *****************************************************************************/
    
/**
 ** Tests for NINV
 **/
    
/*---------------------------------------------------------------------------*/
#include "testunuran.h"
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* global variables                                                          */

static FILE *TESTLOG;               /* test log file                         */
static FILE *UNURANLOG;             /* unuran log file                       */

static int test_ok = TRUE;          /* all tests ok (boolean)                */
static int n_tests_failed;          /* number of failed tests                */

/*---------------------------------------------------------------------------*/

void run_verify_generator( FILE *LOG, int line, UNUR_PAR *par );

int unur_ninv_set_verify( UNUR_PAR *par, int );

/*---------------------------------------------------------------------------*/



/* prototypes */

#define COMPARE_SAMPLE_SIZE   (500)
#define VIOLATE_SAMPLE_SIZE   (20)




/*---------------------------------------------------------------------------*/

#ifndef CHI2_FAILURES_TOLERATED
#  define CHI2_FAILURES_TOLERATED DEFAULT_CHI2_FAILURES_TOLERATED
#endif

/*---------------------------------------------------------------------------*/
/* [verbatim] */



/*---------------------------------------------------------------------------*/
/* [new] */

void test_new (void)
{
	/* start test */
	printf("[new "); fflush(stdout);
	fprintf(TESTLOG,"\n[new]\n");

	/* reset counter */
	n_tests_failed = 0;
  
{ /* invalid NULL ptr */
UNUR_DISTR *distr = NULL;
   distr = NULL; 


unur_errno = 0;
n_tests_failed += (check_expected_NULL(TESTLOG,26,(unur_ninv_new( distr )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,26,UNUR_ERR_NULL)==UNUR_SUCCESS)?0:1;
unur_distr_free(distr);
}

{ /* invalid distribution type */
UNUR_DISTR *distr = NULL;
   distr = unur_distr_discr_new(); 


unur_errno = 0;
n_tests_failed += (check_expected_NULL(TESTLOG,32,(unur_ninv_new( distr )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,32,UNUR_ERR_DISTR_INVALID)==UNUR_SUCCESS)?0:1;
unur_distr_free(distr);
}

{ /* data missing in distribution object */
UNUR_DISTR *distr = NULL;
   distr = unur_distr_cont_new(); 


unur_errno = 0;
/* cdf */
n_tests_failed += (check_expected_NULL(TESTLOG,39,(unur_ninv_new( distr )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,39,UNUR_ERR_DISTR_REQUIRED)==UNUR_SUCCESS)?0:1;
unur_distr_free(distr);
}


	/* test finished */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf(" ==> failed] ") : printf(" ==> ok] ");

#if WITH_DMALLOC
	dmalloc_vmessage("section = new  ================================\n",NULL);
	dmalloc_log_unfreed();
#endif

} /* end of test_new() */

/*---------------------------------------------------------------------------*/
/* [set] */

void test_set (void)
{
	/* start test */
	printf("[set "); fflush(stdout);
	fprintf(TESTLOG,"\n[set]\n");

	/* reset counter */
	n_tests_failed = 0;
  
{ /* invalid NULL ptr */
UNUR_PAR   *par = NULL;
   par = NULL; 


unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,49,(unur_ninv_set_usenewton( par )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,49,UNUR_ERR_NULL)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,52,(unur_ninv_set_useregula( par )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,52,UNUR_ERR_NULL)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,55,(unur_ninv_set_max_iter( par, 40 )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,55,UNUR_ERR_NULL)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,58,(unur_ninv_set_x_resolution( par, 0.001 )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,58,UNUR_ERR_NULL)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,61,(unur_ninv_set_start( par, 0., 1. )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,61,UNUR_ERR_NULL)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,64,(unur_ninv_set_table( par, 100 )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,64,UNUR_ERR_NULL)==UNUR_SUCCESS)?0:1;
}

{ /* invalid parameter object */
UNUR_DISTR *distr = NULL;
UNUR_PAR   *par = NULL;
   double fpar[2] = {0.,1.};
   distr = unur_distr_normal(fpar,2);
   par = unur_arou_new(distr); 


unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,73,(unur_ninv_set_usenewton( par )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,73,UNUR_ERR_PAR_INVALID)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,76,(unur_ninv_set_useregula( par )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,76,UNUR_ERR_PAR_INVALID)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,79,(unur_ninv_set_max_iter( par, 40 )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,79,UNUR_ERR_PAR_INVALID)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,82,(unur_ninv_set_x_resolution( par, 0.001 )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,82,UNUR_ERR_PAR_INVALID)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,85,(unur_ninv_set_start( par, 0., 1. )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,85,UNUR_ERR_PAR_INVALID)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,88,(unur_ninv_set_table( par, 100 )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,88,UNUR_ERR_PAR_INVALID)==UNUR_SUCCESS)?0:1;
unur_par_free(par);
unur_distr_free(distr);
}

{ /* invalid parameters */
UNUR_DISTR *distr = NULL;
UNUR_PAR   *par = NULL;
   double fpar[2] = {0.,1.};
   distr = unur_distr_normal(fpar,2);
   par = unur_ninv_new(distr); 


unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,98,(unur_ninv_set_max_iter( par, 0 )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,98,UNUR_ERR_PAR_SET)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,101,(unur_ninv_set_x_resolution( par, 1e-30 )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,101,UNUR_ERR_PAR_SET)==UNUR_SUCCESS)?0:1;
unur_par_free(par);
unur_distr_free(distr);
}


	/* test finished */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf(" ==> failed] ") : printf(" ==> ok] ");

#if WITH_DMALLOC
	dmalloc_vmessage("section = set  ================================\n",NULL);
	dmalloc_log_unfreed();
#endif

} /* end of test_set() */

/*---------------------------------------------------------------------------*/
/* [get] */

void test_get (void)
{
	/* start test */
	printf("[get "); fflush(stdout);
	fprintf(TESTLOG,"\n[get]\n");

	/* reset counter */
	n_tests_failed = 0;
  

	/* test finished */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf(" ==> failed] ") : printf(" ==> ok] ");

#if WITH_DMALLOC
	dmalloc_vmessage("section = get  ================================\n",NULL);
	dmalloc_log_unfreed();
#endif

} /* end of test_get() */

/*---------------------------------------------------------------------------*/
/* [chg] */

void test_chg (void)
{
	/* start test */
	printf("[chg "); fflush(stdout);
	fprintf(TESTLOG,"\n[chg]\n");

	/* reset counter */
	n_tests_failed = 0;
  
{ /* invalid generator object */
UNUR_DISTR *distr = NULL;
UNUR_PAR   *par = NULL;
UNUR_GEN   *gen = NULL;
   double fpar[2] = {0.,1.};
   distr = unur_distr_normal(fpar,2);
   unur_distr_cont_set_domain(distr,-1.,2.);
   par = unur_ninv_new(distr);
   unur_set_debug(par,0);
   gen = unur_init( par ); 
abort_if_NULL(TESTLOG, 118,    gen );


unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,123,(unur_ninv_chg_max_iter( gen, 0 )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,123,UNUR_ERR_PAR_SET)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,126,(unur_ninv_chg_x_resolution( gen, 1.e-30)))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,126,UNUR_ERR_PAR_SET)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
n_tests_failed += (check_expected_setfailed(TESTLOG,129,(unur_ninv_chg_truncated( gen, 1., 0. )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,129,UNUR_ERR_DISTR_SET)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
unur_ninv_chg_truncated( gen, -2., 0. );
n_tests_failed += (check_errorcode(TESTLOG,132,UNUR_ERR_DISTR_SET)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
unur_ninv_chg_truncated( gen, 0., 10. );
n_tests_failed += (check_errorcode(TESTLOG,135,UNUR_ERR_DISTR_SET)==UNUR_SUCCESS)?0:1;
unur_distr_free(distr);
unur_free(gen);
}


	/* test finished */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf(" ==> failed] ") : printf(" ==> ok] ");

#if WITH_DMALLOC
	dmalloc_vmessage("section = chg  ================================\n",NULL);
	dmalloc_log_unfreed();
#endif

} /* end of test_chg() */

/*---------------------------------------------------------------------------*/
/* [init] */

void test_init (void)
{
	/* start test */
	printf("[init "); fflush(stdout);
	fprintf(TESTLOG,"\n[init]\n");

	/* reset counter */
	n_tests_failed = 0;
  
{ /* invalid NULL ptr */
UNUR_PAR   *par = NULL;
   par = NULL; 


unur_errno = 0;
n_tests_failed += (check_expected_NULL(TESTLOG,146,(unur_init( par )))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,146,UNUR_ERR_NULL)==UNUR_SUCCESS)?0:1;
}


	/* test finished */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf(" ==> failed] ") : printf(" ==> ok] ");

#if WITH_DMALLOC
	dmalloc_vmessage("section = init  ================================\n",NULL);
	dmalloc_log_unfreed();
#endif

} /* end of test_init() */

/*---------------------------------------------------------------------------*/
/* [reinit] */

void test_reinit (void)
{
	/* start test */
	printf("[reinit "); fflush(stdout);
	fprintf(TESTLOG,"\n[reinit]\n");

	/* reset counter */
	n_tests_failed = 0;
  

	/* test finished */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf(" ==> failed] ") : printf(" ==> ok] ");

#if WITH_DMALLOC
	dmalloc_vmessage("section = reinit  ================================\n",NULL);
	dmalloc_log_unfreed();
#endif

} /* end of test_reinit() */

/*---------------------------------------------------------------------------*/
/* [sample] */

void test_sample (void)
{
	/* start test */
	printf("[sample "); fflush(stdout);
	fprintf(TESTLOG,"\n[sample]\n");

	/* reset counter */
	n_tests_failed = 0;
  
{ /* invalid NULL ptr */
UNUR_GEN   *gen = NULL;
   gen = NULL; 


unur_errno = 0;
n_tests_failed += (check_expected_INFINITY(TESTLOG,160,(unur_ninv_eval_approxinvcdf(gen,0.5)))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,160,UNUR_ERR_NULL)==UNUR_SUCCESS)?0:1;
unur_free(gen);
}

{ /* invalid generator object */
UNUR_DISTR *distr = NULL;
UNUR_PAR   *par = NULL;
UNUR_GEN   *gen = NULL;
   distr = unur_distr_normal(NULL,0);
   par = unur_hinv_new(distr);
   gen = unur_init(par); 
abort_if_NULL(TESTLOG, 164,    gen );


unur_errno = 0;
n_tests_failed += (check_expected_INFINITY(TESTLOG,168,(unur_ninv_eval_approxinvcdf(gen,0.5)))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,168,UNUR_ERR_GEN_INVALID)==UNUR_SUCCESS)?0:1;
unur_distr_free(distr);
unur_free(gen);
}

{ /* invalid domain */
UNUR_DISTR *distr = NULL;
UNUR_PAR   *par = NULL;
UNUR_GEN   *gen = NULL;
   distr = unur_distr_normal(NULL,0);
   par = unur_ninv_new(distr);
   unur_set_debug(par,0);
   gen = unur_init( par ); 
abort_if_NULL(TESTLOG, 173,    gen );


unur_errno = 0;
n_tests_failed += (check_expected_INFINITY(TESTLOG,177,(unur_ninv_eval_approxinvcdf(gen,1.5)))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,177,UNUR_ERR_DOMAIN)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
n_tests_failed += (check_expected_negINFINITY(TESTLOG,180,(unur_ninv_eval_approxinvcdf(gen,-0.5)))==UNUR_SUCCESS)?0:1;
n_tests_failed += (check_errorcode(TESTLOG,180,UNUR_ERR_DOMAIN)==UNUR_SUCCESS)?0:1;
unur_distr_free(distr);
unur_free(gen);
}

{ /* compare clone */
UNUR_DISTR *distr = NULL;
UNUR_PAR   *par = NULL;
UNUR_GEN   *gen = NULL;
   UNUR_GEN *clone;
   distr = unur_distr_normal(NULL,0); 
   par = NULL;
   gen = NULL; 


unur_errno = 0;
/* original generator object */
par = unur_ninv_new(distr);
gen = unur_init(par);
n_tests_failed += (compare_double_sequence_gen_start(TESTLOG,193,gen,COMPARE_SAMPLE_SIZE)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
/* clone */
clone = unur_gen_clone(gen);
unur_free(gen);
gen = clone;
n_tests_failed += (compare_double_sequence_gen(TESTLOG,199,gen,COMPARE_SAMPLE_SIZE)==UNUR_SUCCESS)?0:1;
unur_distr_free(distr);
unur_free(gen);
}

{ /* compare stringparser */
UNUR_DISTR *distr = NULL;
UNUR_PAR   *par = NULL;
UNUR_GEN   *gen = NULL;
   double fpar[] = {3.,4.};
   distr = NULL;
   par = NULL;
   gen = NULL; 


unur_errno = 0;
distr = unur_distr_gamma(fpar,2);
unur_distr_cont_set_domain(distr,2,UNUR_INFINITY);
par = unur_ninv_new(distr);
unur_ninv_set_max_iter(par,10);
unur_ninv_set_start(par,4.,10.);
unur_ninv_set_table(par,100);
unur_ninv_set_usenewton(par);
unur_ninv_set_x_resolution(par,1.E-6);
unur_set_debug(par,1u);
gen = unur_init(par);
n_tests_failed += (compare_double_sequence_gen_start(TESTLOG,220,gen,COMPARE_SAMPLE_SIZE)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
unur_free(gen); gen = NULL;
unur_distr_free(distr); distr = NULL;
gen = unur_str2gen( "gamma(3.,4.); domain = 2,infinity & \
  method = ninv; max_iter = 10; start = 4., 10.; table = 100; \
  usenewton; x_resolution = 1.E-6; debug = 0x1" );
n_tests_failed += (compare_double_sequence_gen(TESTLOG,227,gen,COMPARE_SAMPLE_SIZE)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
unur_free(gen); gen = NULL;
distr = unur_distr_gamma(fpar,2);
unur_distr_cont_set_domain(distr,2,UNUR_INFINITY);
par = unur_ninv_new(distr);
unur_ninv_set_useregula(par);
unur_set_debug(par,1u);
gen = unur_init(par);
n_tests_failed += (compare_double_sequence_gen_start(TESTLOG,236,gen,COMPARE_SAMPLE_SIZE)==UNUR_SUCCESS)?0:1;

unur_errno = 0;
unur_free(gen); gen = NULL;
unur_distr_free(distr); distr = NULL;
gen = unur_str2gen( "gamma(3.,4.); domain = (2,inf) & method = ninv; useregula; debug = 0x1" );
n_tests_failed += (compare_double_sequence_gen(TESTLOG,241,gen,COMPARE_SAMPLE_SIZE)==UNUR_SUCCESS)?0:1;
unur_distr_free(distr);
unur_free(gen);
}


	/* test finished */
	test_ok &= (n_tests_failed) ? 0 : 1;
	(n_tests_failed) ? printf(" ==> failed] ") : printf(" ==> ok] ");

#if WITH_DMALLOC
	dmalloc_vmessage("section = sample  ================================\n",NULL);
	dmalloc_log_unfreed();
#endif

} /* end of test_sample() */

/*---------------------------------------------------------------------------*/
/* [validate] */

/*---------------------------------------------------------------------------*/

/* [validate] */

void test_validate (void)
{
	UNUR_DISTR *distr[33];
	UNUR_PAR *par;
	UNUR_GEN *gen;
	int n_tests_failed = 0;
	int rcode;
	double *darray;
	double fpm[10];

	rcode = 0;

	/* start test */
	printf("[validate "); fflush(stdout);
	fprintf(TESTLOG,"\n[validate]\n");

	/* reset counter */
	n_tests_failed = 0;


/* distributions: 33 */
{
fpm[0] = 1.;
fpm[1] = 2.;
distr[0] = unur_distr_beta(fpm,2);
}

{
fpm[0] = 1.;
fpm[1] = 5.;
distr[1] = unur_distr_beta(fpm,2);
}

{
fpm[0] = 1.;
fpm[1] = 100.;
distr[2] = unur_distr_beta(fpm,2);
}

{
fpm[0] = 3.;
fpm[1] = 4.;
distr[3] = unur_distr_beta(fpm,2);
}

{
fpm[0] = 5.;
fpm[1] = 100.;
distr[4] = unur_distr_beta(fpm,2);
}

{
fpm[0] = 500.;
fpm[1] = 300.;
distr[5] = unur_distr_beta(fpm,2);
}

{
fpm[0] = 5.;
fpm[1] = 10.;
fpm[2] = -3.;
fpm[3] = 15.;
distr[6] = unur_distr_beta(fpm,4);
}

{
fpm[0] = 0.5;
fpm[1] = 3.;
distr[28] = unur_distr_beta(fpm,2);
}

{
fpm[0] = 5.;
fpm[1] = 0.3;
distr[29] = unur_distr_beta(fpm,2);
}

{
fpm[0] = 0.5;
fpm[1] = 0.4;
distr[30] = unur_distr_beta(fpm,2);
}

{
distr[7] = unur_distr_cauchy(NULL,0);
}

{
fpm[0] = 1.;
fpm[1] = 20.;
distr[8] = unur_distr_cauchy(fpm,2);
}

{
distr[24] = unur_distr_exponential(NULL,0);
}

{
fpm[0] = 30.;
fpm[1] = -5.;
distr[25] = unur_distr_exponential(fpm,2);
}

{
fpm[0] = 1.;
distr[9] = unur_distr_gamma(fpm,1);
}

{
fpm[0] = 2.;
distr[10] = unur_distr_gamma(fpm,1);
}

{
fpm[0] = 3.;
distr[11] = unur_distr_gamma(fpm,1);
}

{
fpm[0] = 10.;
distr[12] = unur_distr_gamma(fpm,1);
}

{
fpm[0] = 1000.;
distr[13] = unur_distr_gamma(fpm,1);
}

{
fpm[0] = 5.;
fpm[1] = 1000.;
distr[14] = unur_distr_gamma(fpm,2);
}

{
fpm[0] = 5.;
fpm[1] = 1.e-5;
distr[15] = unur_distr_gamma(fpm,2);
}

{
fpm[0] = 5.;
fpm[1] = 10.;
fpm[2] = 1000;
distr[16] = unur_distr_gamma(fpm,3);
}

{
fpm[0] = 0.5;
distr[31] = unur_distr_gamma(fpm,1);
}

{
fpm[0] = 0.2;
distr[32] = unur_distr_gamma(fpm,1);
}

{
distr[26] = unur_distr_laplace(NULL,0);
}

{
fpm[0] = -10.;
fpm[1] = 100.;
distr[27] = unur_distr_laplace(fpm,2);
}

{
distr[17] = unur_distr_normal(NULL,0);
}

{
fpm[0] = 1.;
fpm[1] = 1.e-5;
distr[18] = unur_distr_normal(fpm,2);
}

{
fpm[0] = 0.;
fpm[1] = 1.e+5;
distr[19] = unur_distr_normal(fpm,2);
}

{
distr[20] = unur_distr_uniform(NULL,0);
}

{
fpm[0] = 1.;
fpm[1] = 20.;
distr[21] = unur_distr_uniform(fpm,2);
}

{
distr[22] = unur_distr_cauchy(NULL,0);
unur_distr_cont_set_domain(distr[22],0.1,1.);
unur_distr_cont_upd_mode(distr[22]);
unur_distr_cont_upd_pdfarea(distr[22]);
}

{
fpm[0] = 3.;
fpm[1] = 4.;
distr[23] = unur_distr_beta(fpm,2);
unur_distr_cont_set_domain(distr[23],-2.,5.);
}

	printf("\n(chi^2) "); fflush(stdout);

/* chi^2 tests: 660 */

	unur_set_default_debug(~UNUR_DEBUG_SAMPLE);
	fprintf( TESTLOG,"\nChi^2 Test:\n");

/* distribution [0] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[0]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[0],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [1] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[1]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[1],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [2] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[2]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[2],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [3] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[3]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[3],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [4] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[4]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[4],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [5] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[5]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[5],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [6] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[6]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[6],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [28] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[28]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[28],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [29] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[29]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[29],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [30] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[30]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[30],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [7] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[7]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[7],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [8] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[8]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[8],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [24] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[24]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[24],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [25] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[25]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[25],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [9] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[9]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[9],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [10] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[10]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[10],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [11] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[11]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[11],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [12] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	printf("."); fflush(stdout);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[12]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[12],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [13] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	printf("."); fflush(stdout);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[13]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[13],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [14] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	printf("."); fflush(stdout);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[14]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[14],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [15] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[15]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[15],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [16] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	printf("."); fflush(stdout);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	printf("."); fflush(stdout);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[16]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[16],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [31] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	printf("."); fflush(stdout);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[31]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[31],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [32] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	printf("."); fflush(stdout);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[32]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[32],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [26] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[26]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[26],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [27] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[27]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[27],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [17] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[17]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[17],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [18] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[18]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[18],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [19] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[19]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[19],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [20] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[20]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[20],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [21] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[21]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[21],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [22] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[22]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[22],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

/* distribution [23] */

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_max_iter (par, 100);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_usenewton(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_start(par, 0.1, 0.9);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_truncated(gen,0.5,0.9);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,11);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);

	do {
	UNUR_DISTR *distr_localcopy = unur_distr_clone(distr[23]);
	unur_errno = 0;
par = unur_ninv_new(distr_localcopy);
unur_ninv_set_useregula(par);
unur_ninv_set_table(par,1000);
fpm[0] = 2.;
fpm[1] = 4.;
	gen = unur_init(par);
	if (gen) {
unur_ninv_chg_pdfparams(gen,fpm,2);
	}
	rcode = run_validate_chi2(TESTLOG,0,gen,distr[23],0,'+');
	n_tests_failed += (rcode==UNUR_SUCCESS)?0:1;
	n_tests_failed += (rcode==UNUR_FAILURE)?1000:0;
	unur_free(gen);
	unur_distr_free(distr_localcopy);
	} while (0);


/* free distributions */
	unur_distr_free(distr[0]);
	unur_distr_free(distr[1]);
	unur_distr_free(distr[2]);
	unur_distr_free(distr[3]);
	unur_distr_free(distr[4]);
	unur_distr_free(distr[5]);
	unur_distr_free(distr[6]);
	unur_distr_free(distr[7]);
	unur_distr_free(distr[8]);
	unur_distr_free(distr[9]);
	unur_distr_free(distr[10]);
	unur_distr_free(distr[11]);
	unur_distr_free(distr[12]);
	unur_distr_free(distr[13]);
	unur_distr_free(distr[14]);
	unur_distr_free(distr[15]);
	unur_distr_free(distr[16]);
	unur_distr_free(distr[17]);
	unur_distr_free(distr[18]);
	unur_distr_free(distr[19]);
	unur_distr_free(distr[20]);
	unur_distr_free(distr[21]);
	unur_distr_free(distr[22]);
	unur_distr_free(distr[23]);
	unur_distr_free(distr[24]);
	unur_distr_free(distr[25]);
	unur_distr_free(distr[26]);
	unur_distr_free(distr[27]);
	unur_distr_free(distr[28]);
	unur_distr_free(distr[29]);
	unur_distr_free(distr[30]);
	unur_distr_free(distr[31]);
	unur_distr_free(distr[32]);
#if WITH_DMALLOC
	dmalloc_vmessage("section = validate  ================================\n","");
	dmalloc_log_unfreed();
#endif


	/* test finished */
	test_ok &= (n_tests_failed>CHI2_FAILURES_TOLERATED) ? 0 : 1;
	/* we accept CHI2_FAILURES_TOLERATED failures */
	(n_tests_failed>CHI2_FAILURES_TOLERATED) ? printf(" ==> failed] ") : printf(" ==> ok] ");

	/* prevent compiler from making useless annoying warnings */
	distr[0] = NULL;
	par = NULL;
	gen = NULL;
	darray = NULL;
	fpm[0] = 0.;

} /* end of test_validate */


/*---------------------------------------------------------------------------*/
/* run generator in verifying mode */

void run_verify_generator( FILE *LOG, int line, UNUR_PAR *par )
{
	UNUR_GEN *gen;
	int i;

	/* switch to verifying mode */
	unur_ninv_set_verify(par,1);

	/* initialize generator */
	gen = unur_init( par ); abort_if_NULL(LOG, line, gen);

	/* run generator */
	for (i=0; i<VIOLATE_SAMPLE_SIZE; i++)
		unur_sample_cont(gen);

	/* destroy generator */
	unur_free(gen); 

} /* end of run_verify_generator() */

int unur_ninv_set_verify(UNUR_PAR *par, int verify) {return 0;}

/*---------------------------------------------------------------------------*/

int main()
{ 
	/* open log file for unuran and set output stream for unuran messages */
	UNURANLOG = fopen( "t_ninv_unuran.log","w" );
	abort_if_NULL( stderr,-1, UNURANLOG );
	unur_set_stream( UNURANLOG );

	/* open log file for testing */
	TESTLOG = fopen( "t_ninv_test.log","w" );
	abort_if_NULL( stderr,-1, TESTLOG );

	/* write header into log file */
  	{
		time_t started;  
		fprintf(TESTLOG,"\nUNURAN - Universal Non-Uniform RANdom number generator\n\n");
		if (time( &started ) != -1)
			fprintf(TESTLOG,"%s",ctime(&started));
		fprintf(TESTLOG,"\n====================================================\n\n");
	}

        /* seed build-in uniform generators */
        unur_urng_MRG31k3p_seed(342343);
	unur_urng_fish_seed(342343);
	unur_urng_mstd_seed(342343);

	/* seed uniform random number generator */
#if UNUR_URNG_TYPE == UNUR_URNG_GENERIC
/*
	if (unur_urng_seed(NULL, 342343) != UNUR_SUCCESS) {
	  fprintf(stderr,"WARNING: Seed could not be set at random\n");
	}  
*/
#elif UNUR_URNG_TYPE == UNUR_URNG_PRNG
	unur_set_default_urng(prng_new("mt19937(342343)"));
#elif UNUR_URNG_TYPE == UNUR_URNG_RNGSTREAM
	{
	    unsigned long seed[6] = {342343,342343,342343,342343,342343,342343};
	    RngStream_SetPackageSeed(seed);
	}
#endif  /* UNUR_URNG_TYPE */

	/* set default debugging flag */
	unur_set_default_debug(UNUR_DEBUG_ALL);

	/* start test */
	printf("ninv: ");

	/* run tests */
test_new();
test_set();
test_get();
test_chg();
test_init();
test_reinit();
test_sample();
test_validate();


	/* test finished */
	printf("\n");  fflush(stdout);

	/* close log files */
	fprintf(TESTLOG,"\n====================================================\n\n");
	if (test_ok)
		fprintf(TESTLOG,"All tests PASSED.\n");
	else
		fprintf(TESTLOG,"Test(s) FAILED.\n");

	fclose(UNURANLOG);
	fclose(TESTLOG);

	/* free memory */
        compare_free_memory();

	/* exit */
	exit( (test_ok) ? EXIT_SUCCESS : EXIT_FAILURE );

} /* end of main */

